package Client;

import javax.swing.table.TableModel;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class ClientFrame extends JFrame
{
    private Controller controller;

    private JPanel contentPane;
    private JMenuBar jMenuBar1 = new JMenuBar();
    private JMenu jMenuAcco = new JMenu();
    private JMenuItem jMenuAccoLogin = new JMenuItem();
    private JMenuItem jMenuAccoLogout = new JMenuItem();
    private JMenuItem jMenuAccoRegister = new JMenuItem();
    private JMenuItem jMenuAccoManage = new JMenuItem();
    private JMenu jMenuItem = new JMenu();
    private JMenuItem jMenuItemAll = new JMenuItem();
    private JMenuItem jMenuItemDetail = new JMenuItem();
    private JMenuItem jMenuItemSearch = new JMenuItem();
    private JMenu jMenuTrans = new JMenu();
    private JMenuItem jMenuTranSell = new JMenuItem();
    private JMenuItem jMenuTranBuy = new JMenuItem();
    private JMenuItem jMenuTranHistory = new JMenuItem();
    private JMenu jMenuHelp = new JMenu();
    private JMenuItem jMenuHelpAbout = new JMenuItem();
    private BorderLayout borderLayout1 = new BorderLayout();
    private JLabel jLabel1 = new JLabel();
    private JTable jTable1;
    private JMenuItem jMenutranCancel = new JMenuItem();


    //Construct the frame
    public ClientFrame(Controller ctrl)
    {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);

        this.controller=ctrl;

        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }

    }
    //Component initialization
    private void jbInit() throws Exception
    {
        //setIconImage(Toolkit.getDefaultToolkit().createImage(MainFrame.class.getResource("[Your Icon]")));
        contentPane = (JPanel) this.getContentPane();
        contentPane.setLayout(borderLayout1);
        this.setResizable(false);
        this.setSize(new Dimension(544, 404));
        this.setTitle("Unicommerce (Not Logged in)");

        jMenuAcco.setText("My Account");
        jMenuAccoLogin.setText("Login");
        jMenuAccoLogin.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuAccoLogin_actionPerformed(e);
            }
        });
        jMenuAccoLogout.setText("Logout");
        jMenuAccoLogout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuAccoLogout_actionPerformed(e);
            }
        });
        jMenuAccoRegister.setText("Register");
        jMenuAccoRegister.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuAccoRegister_actionPerformed(e);
            }
        });
        jMenuAccoManage.setText("Manage");
        jMenuAccoManage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuAccoManage_actionPerformed(e);
            }
        });

        jMenuItem.setText("Items");
        jMenuItemAll.setText("Browse All");
        jMenuItemAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItemAll_actionPerformed(e);
            }
        });
        jMenuItemDetail.setText("View Detail");
        jMenuItemDetail.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItemDetail_actionPerformed(e);
            }
        });
        jMenuItemSearch.setText("Searh");
        jMenuItemSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItemSearch_actionPerformed(e);
            }
        });

        jMenuTrans.setText("Transaction");
        jMenuTranSell.setText("Sell");
        jMenuTranSell.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuTranSell_actionPerformed(e);
            }
        });
        jMenuTranBuy.setText("Buy");
        jMenuTranBuy.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuTranBuy_actionPerformed(e);
            }
        });
        jMenuTranHistory.setText("History");
        jMenuTranHistory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuTranHistory_actionPerformed(e);
            }
        });

        jMenuHelp.setText("Help");
        jMenuHelpAbout.setText("About Unicommerce");
        jMenuHelpAbout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuHelpAbout_actionPerformed(e);
            }
        });


        contentPane.setEnabled(true);
        contentPane.setMinimumSize(new Dimension(540, 360));

        jTable1 = new JTable(controller.itemTableModel);

        jLabel1.setBackground(Color.black);
        jLabel1.setFont(new java.awt.Font("Dialog", 1, 12));
        jLabel1.setText("Header here");
        jMenutranCancel.setText("Sell Cancel");
        jMenutranCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenutranCancel_actionPerformed(e);
            }
        });
        jMenuAcco.add(jMenuAccoLogin);
        jMenuAcco.add(jMenuAccoLogout);
        jMenuAcco.addSeparator();
        jMenuAcco.add(jMenuAccoRegister);
        jMenuAcco.add(jMenuAccoManage);
        jMenuBar1.add(jMenuAcco);
        jMenuBar1.add(jMenuItem);
        jMenuBar1.add(jMenuTrans);
        jMenuBar1.add(jMenuHelp);
        jMenuItem.add(jMenuItemAll);
        jMenuItem.add(jMenuItemSearch);
        jMenuItem.addSeparator();
        jMenuItem.add(jMenuItemDetail);
        jMenuTrans.add(jMenuTranSell);
        jMenuTrans.add(jMenuTranBuy);
        jMenuTrans.add(jMenutranCancel);
        jMenuTrans.addSeparator();
        jMenuTrans.add(jMenuTranHistory);
        jMenuHelp.add(jMenuHelpAbout);
        contentPane.add(jLabel1, BorderLayout.NORTH);
        contentPane.add(jTable1, BorderLayout.CENTER);

        this.setJMenuBar(jMenuBar1);
    }
    //File | Exit action performed
    public void jMenuAccoLgi_actionPerformed(ActionEvent e)
    {
        System.exit(0);
    }
    //Help | About action performed
    //Overridden so we can exit when window is closed
    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            jMenuAccoLgi_actionPerformed(null);
        }
    }

    public void updateView()
    {
        if(controller.logged) this.jMenuAccoLogin.setEnabled(false);
        else this.jMenuAccoLogin.setEnabled(true);
        if(controller.logged) this.jMenuAccoLogout.setEnabled(true);
        else this.jMenuAccoLogout.setEnabled(false);
        if(controller.logged) this.jMenuAccoManage.setEnabled(true);
        else this.jMenuAccoManage.setEnabled(false);
        if(controller.logged) this.jMenuAccoRegister.setEnabled(false);
        else this.jMenuAccoRegister.setEnabled(true);
        if(controller.logged) this.jMenuTranBuy.setEnabled(true);
        else this.jMenuTranBuy.setEnabled(false);
        if(controller.logged) this.jMenuTranSell.setEnabled(true);
        else this.jMenuTranSell.setEnabled(false);
        if(controller.logged) this.jMenutranCancel.setEnabled(true);
        else this.jMenutranCancel.setEnabled(false);
        if(controller.logged) this.jMenuTranHistory.setEnabled(true);
        else this.jMenuTranHistory.setEnabled(false);
        if(controller.logged) this.setTitle("Welcome to Unicommerce: "+controller.u_fname);
        else this.setTitle("Welcome to Unicommerce (Not logged in)");

        String head="";
        for(int i=0;i<controller.itemColumn.length;i++) head+="                       "+controller.itemColumn[i];
        this.jLabel1.setText(head);

        jTable1.updateUI();
    }

    public void showMessage(String message, String info)
    {
        MessageDialog messageDialog=new MessageDialog(this,message,info,true);
        messageDialog.show();
    }

    void jMenuHelpAbout_actionPerformed(ActionEvent e)
    {
        HelpDialog help=new HelpDialog(this);
        help.show();
    }

    void jMenuAccoLogin_actionPerformed(ActionEvent e)
    {
        LoginDialog loginDialog = new LoginDialog(this,controller);
        loginDialog.show();
    }

    void jMenuAccoLogout_actionPerformed(ActionEvent e)
    {
        controller.logout();
    }

    void jMenuAccoRegister_actionPerformed(ActionEvent e)
    {
        RegisterDialog registerDialog = new RegisterDialog(this,controller);
        registerDialog.show();
    }

    void jMenuAccoManage_actionPerformed(ActionEvent e)
    {
        ManageDialog manageDialog = new ManageDialog(this,controller);
        manageDialog.show();
    }

    void jMenuItemAll_actionPerformed(ActionEvent e)
    {
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        controller.search("","");
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }

    void jMenuItemSearch_actionPerformed(ActionEvent e)
    {
        SearchDialog searchDialog = new SearchDialog(this,controller);
        searchDialog.show();
    }

    void jMenuTranSell_actionPerformed(ActionEvent e)
    {
        SellDialog sellDialog = new SellDialog(this,controller);
        sellDialog.show();
    }

    void jMenuTranBuy_actionPerformed(ActionEvent e)
    {
        if(jTable1.getSelectedRow()<0 || jTable1.getSelectedRow()>=jTable1.getRowCount())
        {
            showMessage("No item is slected to buy","Please select an item first");
            return;
        }

        BuyDialog buyDialog=new BuyDialog(this,controller,jTable1.getSelectedRow());
        buyDialog.show();
    }

    void jMenutranCancel_actionPerformed(ActionEvent e)
    {
        if(jTable1.getSelectedRow()<0 || jTable1.getSelectedRow()>=jTable1.getRowCount())
        {
            showMessage("No item is slected to buy","Please select an item first");
            return;
        }

        SellCancelDialog sellCancelDialog=new SellCancelDialog(this,controller,jTable1.getSelectedRow());
        sellCancelDialog.show();
    }

    void jMenuItemDetail_actionPerformed(ActionEvent e)
    {
        if(jTable1.getSelectedRow()<0 || jTable1.getSelectedRow()>=jTable1.getRowCount())
        {
            showMessage("No item is slected to show","Please select an item first");
            return;
        }

        DetailDialog detailDialog=new DetailDialog(this,controller,jTable1.getSelectedRow());
        detailDialog.show();
    }

    void jMenuTranHistory_actionPerformed(ActionEvent e)
    {
        HistoryDialog historyDialog = new HistoryDialog(this,controller);
        historyDialog.show();
    }
}
