package Client;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class LoginDialog extends JDialog
{
    private Controller controller;
    private JLabel jLabel1 = new JLabel();
    private JLabel jLabel2 = new JLabel();
    private JTextField jTextField1 = new JTextField();
    private TextField jTextField2 = new TextField();
    private JButton jButton1 = new JButton();
    private JButton jButton2 = new JButton();
    private XYLayout xYLayout1 = new XYLayout();

    public LoginDialog(Frame frame, Controller controller)
    {
        super(frame, "Login to Unicommerce", true);
        this.controller=controller;
        try
        {
            jbInit();
            pack();
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }

        setLocation(frame.getLocationOnScreen().x+(frame.getWidth()- this.getWidth())/2,
                  frame.getLocationOnScreen().y+(frame.getHeight()- this.getHeight())/2);
   }

    private void jbInit() throws Exception
    {
        jLabel1.setText("Login ID");
        jLabel2.setText("Password");
        jButton1.setPreferredSize(new Dimension(80, 20));
        jButton1.setText("OK");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton1_actionPerformed(e);
            }
        });
        jButton2.setText("Cancel");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton2_actionPerformed(e);
            }
        });
        jButton2.setPreferredSize(new Dimension(80, 20));
        jTextField2.setEchoChar('*');
        this.getContentPane().setLayout(xYLayout1);
        this.setResizable(false);
        xYLayout1.setWidth(260);
        xYLayout1.setHeight(110);
        this.getContentPane().add(jLabel1,  new XYConstraints(19, 16, 54, -1));
        this.getContentPane().add(jTextField1,  new XYConstraints(86, 12, 151, -1));
        this.getContentPane().add(jTextField2,  new XYConstraints(86, 42, 150, -1));
        this.getContentPane().add(jLabel2,  new XYConstraints(19, 44, 57, -1));
        this.getContentPane().add(jButton1,  new XYConstraints(70, 74, 75, 24));
        this.getContentPane().add(jButton2,  new XYConstraints(158, 74, 78, 24));
    }

    void jButton2_actionPerformed(ActionEvent e)
    {
        this.dispose();
    }

    void jButton1_actionPerformed(ActionEvent e)
    {
        this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        controller.login(jTextField1.getText(),jTextField2.getText());
        if(controller.logged) this.dispose();
        this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }
}
