package Client;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class SearchDialog extends JDialog {
    private Controller controller;

    private JPanel panel1 = new JPanel();
    private XYLayout xYLayout1 = new XYLayout();
    private JLabel jLabel1 = new JLabel();
    private JLabel jLabel2 = new JLabel();
    private JLabel jLabel3 = new JLabel();
    private JTextField jTextField1 = new JTextField();
    private JTextField jTextField2 = new JTextField();
    private JButton jButton1 = new JButton();
    private JButton jButton2 = new JButton();
    private XYLayout xYLayout2 = new XYLayout();

    public SearchDialog(Frame frame, Controller controller) {
        super(frame, "Search interested items", true);
        try
        {
            jbInit();
            pack();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }

        this.controller=controller;

        setLocation(frame.getLocationOnScreen().x+(frame.getWidth()- this.getWidth())/2,
                  frame.getLocationOnScreen().y+(frame.getHeight()- this.getHeight())/2);
   }

    private void jbInit() throws Exception {
        panel1.setLayout(xYLayout1);
        jLabel1.setText("Please enter your search criteria");
        jLabel2.setToolTipText("");
        jLabel2.setText("Category");
        jLabel3.setText("Name");
        jButton1.setMaximumSize(new Dimension(80, 20));
        jButton1.setMinimumSize(new Dimension(80, 20));
        jButton1.setPreferredSize(new Dimension(80, 20));
        jButton1.setText("Search");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton1_actionPerformed(e);
            }
        });
        jButton2.setText("Cancel");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton2_actionPerformed(e);
            }
        });
        jButton2.setPreferredSize(new Dimension(80, 20));
        jButton2.setMinimumSize(new Dimension(80, 20));
        jButton2.setMaximumSize(new Dimension(80, 20));
        this.getContentPane().setLayout(xYLayout2);
        xYLayout2.setWidth(207);
        xYLayout2.setHeight(147);
        panel1.add(jLabel1,     new XYConstraints(16, 12, 356, -1));
        panel1.add(jButton1,  new XYConstraints(18, 109, -1, 22));
        panel1.add(jButton2, new XYConstraints(105, 108, -1, 23));
        panel1.add(jTextField1,  new XYConstraints(83, 38, 96, -1));
        panel1.add(jLabel3, new XYConstraints(23, 75, -1, -1));
        panel1.add(jTextField2, new XYConstraints(84, 74, 96, -1));
        panel1.add(jLabel2, new XYConstraints(24, 39, 54, -1));
        this.getContentPane().add(panel1,     new XYConstraints(0, 0, 204, 137));
    }

    void jButton2_actionPerformed(ActionEvent e)
    {
        dispose();
    }

    void jButton1_actionPerformed(ActionEvent e)
    {
       this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
       controller.search(jTextField1.getText(),jTextField2.getText());
       dispose();
       this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }
}
