package Client;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;

public class HistoryDialog extends JDialog implements Runnable
{
    private Controller controller;

    private JPanel panel1 = new JPanel();
    private XYLayout xYLayout1 = new XYLayout();
    private JLabel jLabel1 = new JLabel();
    private List list1 = new List();
    private Button button1 = new Button();
    private XYLayout xYLayout2 = new XYLayout();

    public HistoryDialog(Frame frame, Controller controller)
    {
        super(frame, "View your history transcation activity", true);
        try
        {
            jbInit();
            pack();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }

        this.controller=controller;

        setLocation(frame.getLocationOnScreen().x+(frame.getWidth()- this.getWidth())/2,
                  frame.getLocationOnScreen().y+(frame.getHeight()- this.getHeight())/2);

        new Thread(this).start();
    }

    public void run()
    {
        this.setCursor(new Cursor(Cursor.WAIT_CURSOR));

        String [] historyItems = controller.history();

        for (int i=0; i<historyItems.length; i++)
        {
            list1.add(historyItems[i]);
        }

        this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }

    private void jbInit() throws Exception {
        panel1.setLayout(xYLayout1);
        jLabel1.setText("Below is your transaction history");
        button1.setLabel("OK");
        button1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                button1_actionPerformed(e);
            }
        });
        this.getContentPane().setLayout(xYLayout2);
        xYLayout2.setWidth(403);
        xYLayout2.setHeight(305);
        panel1.add(jLabel1,    new XYConstraints(9, 7, 349, 21));
        panel1.add(list1,          new XYConstraints(8, 30, 383, 226));
        panel1.add(button1,       new XYConstraints(314, 264, 75, 25));
        this.getContentPane().add(panel1,   new XYConstraints(0, 0, -1, 303));
    }

    void button1_actionPerformed(ActionEvent e)
    {
        this.dispose();
    }
}