package Server;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;

public class ServerFrame extends JFrame
{
    public UniServer uniServer;

    private JPanel contentPane;
    private XYLayout xYLayout1 = new XYLayout();
    private JTextField jTextField1 = new JTextField();
    private JButton jButton1 = new JButton();
    private JLabel jLabel1 = new JLabel();
    private List list1 = new List();

    public ServerFrame(UniServer uniServer)
    {
        this.uniServer=uniServer;

        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception
    {
        contentPane = (JPanel) this.getContentPane();
        jTextField1.setText("localhost");
        contentPane.setLayout(xYLayout1);
        this.setSize(new Dimension(400, 330));
        this.setTitle("Welcome to UniServer");
        jButton1.setText("Connect");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton1_actionPerformed(e);
            }
        });
        jLabel1.setText("SQL Server:");
        contentPane.add(jButton1,     new XYConstraints(307, 12, -1, 25));
        contentPane.add(jTextField1,  new XYConstraints(80, 14, 218, -1));
        contentPane.add(list1,      new XYConstraints(6, 46, 383, 246));
        contentPane.add(jLabel1,   new XYConstraints(5, 16, 72, -1));
    }

    protected void processWindowEvent(WindowEvent e)
    {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING)
        {
            uniServer.disconnectDB();
            System.exit(0);
        }
    }

    void jButton1_actionPerformed(ActionEvent e)
    {
        uniServer.connectDB(jTextField1.getText());
        jButton1.setEnabled(false);
        jTextField1.setEnabled(false);
    }

    void output(String head, String owner, String message)
    {
        list1.add(head+": "+owner+": "+message);
    }
}